signature CDOCS = sig

  datatype cdoc =
    Txt of Context.ctxt * string
  | Ws  of Context.ctxt * string
  | Nd  of Context.ctxt * SMLNG.tag * cdoc JoinList.jlist
  type cdocs = cdoc JoinList.jlist

  val ctxt : cdoc -> Context.ctxt
  val tag  : cdoc -> SMLNG.tag option

  val fold : {kNil: unit -> 'b,
	      kCons:('a * 'b) -> 'b,
	      kTxt:(Context.ctxt * string) -> 'a,
	      kWs:(Context.ctxt * string) -> 'a,
	      kNd:(Context.ctxt * SMLNG.tag * 'b) -> 'a} -> cdocs -> 'b

  val fromDoc : SMLNG.doc -> cdocs
  val toDoc   : cdocs -> SMLNG.doc
  (* removes needless and bougs cdocs *)
  val toCleanDoc : cdocs -> SMLNG.doc
end
