structure CDocs :> CDOCS =
  struct
  datatype cdoc =
    Txt of Context.ctxt * string
  | Ws  of Context.ctxt * string
  | Nd  of Context.ctxt * SMLNG.tag * cdoc JoinList.jlist
  type cdocs = cdoc JoinList.jlist
  structure JL = JoinList
  fun fold (k as {kNil,kCons,kTxt,kWs,kNd}) cdocs = let
    fun f (Txt x) = kTxt x
      | f (Ws x) = kWs x
      | f (Nd (c,t,cds)) = kNd(c,t,g cds)
    and g cds =
      JL.fold (fn JL.Nil => kNil () 
                | JL.Cons(x,xs) => kCons(f x,xs)) cds
  in g cdocs
  end

    fun fromDoc doc = Context.fold_with_ctxt 
      {kSeq=JL.append,
       kTxt=(fn (c,s) => JL.one (Txt(c,s))),
       kWs=(fn (c,s) => JL.one (Ws(c,s))),
       kNd=(fn (c,t,a) => JL.one (Nd(c,t,a)))} Context.init doc

    fun toDoc cdocs = 
      fold {kNil=(fn () => (SMLNG.Txt "")),
	    kCons=(fn (x,xs) => (SMLNG.Seq(x,xs))),
	    kTxt=(fn (c,s) => SMLNG.Txt s),
	    kWs=(fn (c,s) => SMLNG.Ws s),
	    kNd=(fn (c,t,x) => SMLNG.Nd(t,x))} cdocs

    fun toCleanDoc cdocs = 
      fold {kNil=(fn () => (SMLNG.Txt "")),
	    kCons=(fn (x,xs) => (SMLNG.Seq(x,xs))),
	    kTxt=(fn (c,s) => SMLNG.Txt s),
	    kWs=(fn (c,s) => SMLNG.Ws s),
	    kNd=(fn (c,t,SMLNG.Txt "") => SMLNG.Txt ""
	          | (c,t,SMLNG.Ws "") => SMLNG.Ws ""
	          | (c,t,ds) => 
		 if Context.isNop(t,c) then ds
		 else SMLNG.Nd(t,ds))} cdocs

    fun ctxt (Txt(c,_)) = c
      | ctxt (Ws(c,_)) = c
      | ctxt (Nd(c,_,_)) = c

    fun tag (Nd(_,t,_)) = SOME t
      | tag _ = NONE 

  end
