(* The attributes of text is organized in the following way to
 facilitate computing the # of sharings:
digit: 0  1  2  3  4  5  6  7  8  9  10 11 12 13
       B  I  TT EM S  PL r  g  b  c  m  y  k  w
       14 15 16 17 18 19 ... 27
       U0 U1 U2 U3 0  1  ... 9 *)

signature NORMAL_NG = sig
    datatype normal =
      Seq of normal * normal
    | Txt of int * string
    | Nd of tag * normal
    and tag =
        B
      | EM
      | I
      | PL
      | S
      | TT
      | U of int
      | Size  of int
      | Color of color
  and color =  Red | Green | Blue | Cyan | Magenta | Yellow | Black | White

  val get : int -> tag -> bool
  val set : int -> tag -> int
  val clear : int -> tag -> int

  val get_color : int -> color
  val get_size : int -> int
  val get_U : int -> int

  val common : int -> int -> int
  (* common gives # of same tags between two attribute ints *)

  val print : normal -> TextIO.outstream -> unit
  end
