signature SML_NG = sig

  datatype doc =
    Seq of doc * doc
  | Txt of string
  | Ws  of string
  | Nd  of tag * doc
  and tag =
      B
    | EM
    | I
    | PL
    | S
    | TT
    | U
    | Size  of Word.word
    | Color of color 
  and color =  Red | Green | Blue | Cyan | Magenta | Yellow | Black | White

  val tag2str : tag -> string
  val str2tag : string -> tag    

  val parse   : TextIO.instream -> doc
  val print   : doc -> TextIO.outstream -> unit
  val size    : doc -> int

  val fold    : {kSeq:'a * 'a -> 'a,
		 kTxt:string -> 'a,
		 kWs:string -> 'a,
		 kNd:tag * 'a -> 'a} -> doc -> 'a
    
end
